Sólo en mainline-2cce7a3db9ce-libproxy: aclocal.m4
Sólo en mainline-2cce7a3db9ce-libproxy: autom4te.cache
Sólo en mainline-2cce7a3db9ce-libproxy: configure
diff -ru mainline-2cce7a3db9ce/configure.ac mainline-2cce7a3db9ce-libproxy/configure.ac
--- mainline-2cce7a3db9ce/configure.ac	2009-07-23 14:24:36.000000000 -0300
+++ mainline-2cce7a3db9ce-libproxy/configure.ac	2009-07-24 09:19:18.000000000 -0300
@@ -352,6 +352,22 @@
   AC_DEFINE([HAVE_MD5], 1, [Define if we're compiling support for MD5.])
 fi
 
+dnl
+dnl libproxy support
+dnl
+AC_ARG_ENABLE(libproxy,
+  [  --enable-libproxy       libproxy support for system wide proxy configuration])
+if test "${enable_libproxy}" != "no"
+then
+  PKG_CHECK_MODULES([libproxy], [libproxy-1.0], [enable_libproxy=yes], [enable_libproxy=no])
+fi
+if test "${enable_libproxy}" = "yes"
+then
+  AC_SUBST(libproxy_CFLAGS)
+  AC_SUBST(libproxy_LIBS)
+  AC_DEFINE([HAVE_LIBPROXY], 1, [Define when using libproxy])
+fi
+
 dnl **********************************************************************
 dnl Checks for IPv6
 dnl **********************************************************************
Sólo en mainline-2cce7a3db9ce-libproxy/doc: Makefile.in
Sólo en mainline-2cce7a3db9ce-libproxy/doc: sample.wgetrc.munged_for_texi_inclusion
Sólo en mainline-2cce7a3db9ce-libproxy/doc: stamp-vti
Sólo en mainline-2cce7a3db9ce-libproxy/doc: version.texi
Sólo en mainline-2cce7a3db9ce-libproxy/doc: wget.info
Sólo en mainline-2cce7a3db9ce-libproxy: index.html
Sólo en mainline-2cce7a3db9ce-libproxy/lib: Makefile.in
Sólo en mainline-2cce7a3db9ce-libproxy: Makefile.in
Sólo en mainline-2cce7a3db9ce-libproxy/md5: Makefile.in
Sólo en mainline-2cce7a3db9ce-libproxy/po: be.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: bg.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: ca.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: cs.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: da.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: de.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: el.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: en@boldquot.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: en@boldquot.po
Sólo en mainline-2cce7a3db9ce-libproxy/po: en_GB.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: en@quot.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: en@quot.po
Sólo en mainline-2cce7a3db9ce-libproxy/po: en_US.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: eo.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: es.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: et.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: eu.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: fi.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: fr.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: ga.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: gl.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: he.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: hr.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: hu.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: id.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: it.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: ja.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: lt.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: nb.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: nl.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: pl.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: pt_BR.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: pt.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: ro.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: ru.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: sk.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: sl.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: sr.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: sv.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: tr.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: uk.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: vi.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: wget.pot
Sólo en mainline-2cce7a3db9ce-libproxy/po: zh_CN.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/po: zh_TW.gmo
Sólo en mainline-2cce7a3db9ce-libproxy/src: config.h.in
Sólo en mainline-2cce7a3db9ce-libproxy/src: css.c
diff -ru mainline-2cce7a3db9ce/src/Makefile.am mainline-2cce7a3db9ce-libproxy/src/Makefile.am
--- mainline-2cce7a3db9ce/src/Makefile.am	2009-07-23 14:24:36.000000000 -0300
+++ mainline-2cce7a3db9ce-libproxy/src/Makefile.am	2009-07-24 09:18:19.000000000 -0300
@@ -36,7 +36,7 @@
 
 # The following line is losing on some versions of make!
 DEFS     = @DEFS@ -DSYSTEM_WGETRC=\"$(sysconfdir)/wgetrc\" -DLOCALEDIR=\"$(localedir)\"
-LIBS     = @LIBSSL@ @LIBGNUTLS@ @LIBICONV@ @LIBINTL@ @LIBS@
+LIBS     = @LIBSSL@ @LIBGNUTLS@ @LIBICONV@ @LIBINTL@ @libproxy_LIBS@ @LIBS@
 
 bin_PROGRAMS = wget
 wget_SOURCES = cmpt.c connect.c convert.c cookies.c ftp.c    		  \
Sólo en mainline-2cce7a3db9ce-libproxy/src: Makefile.in
diff -ru mainline-2cce7a3db9ce/src/retr.c mainline-2cce7a3db9ce-libproxy/src/retr.c
--- mainline-2cce7a3db9ce/src/retr.c	2009-07-23 14:24:36.000000000 -0300
+++ mainline-2cce7a3db9ce-libproxy/src/retr.c	2009-07-24 09:20:08.000000000 -0300
@@ -54,6 +54,10 @@
 #include "html-url.h"
 #include "iri.h"
 
+#ifdef HAVE_LIBPROXY
+#include "proxy.h"
+#endif
+
 /* Total size of downloaded files.  Used to enforce quota.  */
 SUM_SIZE_INT total_downloaded_bytes;
 
@@ -1126,7 +1130,36 @@
       break;
     }
   if (!proxy || !*proxy)
-    return NULL;
+#ifdef HAVE_LIBPROXY
+  {
+	pxProxyFactory *pf = px_proxy_factory_new();
+        if (!pf)
+        {
+		logprintf (LOG_VERBOSE, _("Allocating memory for libproxy failed"));
+                return NULL;
+        }
+	int i;
+	logprintf (LOG_VERBOSE, _("asking libproxy about url '%s'\n"), u->url);
+	char **proxies = px_proxy_factory_get_proxies(pf, u->url);
+	if (proxies[0])
+	{
+	    logprintf (LOG_VERBOSE, _("libproxy suggest to use '%s'\n"), proxies[0]);
+	    if(proxies[0] != "direct://")
+	    {
+		i=asprintf(&proxy , "%s", proxies[0]);
+  	        //logprintf (LOG_NONVERBOSE, _("libproxy setting to use '%s'\n"), proxy);
+	    }
+	}
+	for(i=0;proxies[i];i++) free(proxies[i]);
+	free(proxies);
+	free(pf);
+        
+        if (!proxy || !*proxy)
+	    return NULL;
+  }
+#else
+     return NULL;
+#endif
 
   /* Handle shorthands.  `rewritten_storage' is a kludge to allow
      getproxy() to return static storage. */
Sólo en mainline-2cce7a3db9ce-libproxy/tests: Makefile.in
Sólo en mainline-2cce7a3db9ce-libproxy/util: Makefile.in
Sólo en mainline-2cce7a3db9ce-libproxy/windows: Makefile.in